/* tslint:disable */
/* eslint-disable */
/**
* No error reporting included. To get the detailed error code, use `BrotliDecStream`.
* @param {Uint8Array} input
* @returns {Uint8Array}
*/
export function brotliDec(input: Uint8Array): Uint8Array;
/**
*/
export enum BrotliDecStreamResult {
/**
* The stream is just inited and have not been runned.
* `BrotliResult` uses `ResultFailure = 0`, but as we will convert `ResultFailure` to a negative actual error code,
* 0 is reused as no input currently.
*/
  Init,
  ResultSuccess,
  NeedsMoreInput,
  NeedsMoreOutput,
}
/**
* Copied and modified from enum BrotliDecoderErrorCode of dropbox/rust-brotli-decompressor.
* It is not PascalCase but kept in MACRO_CASE because changing all names is too troublesome.
* And most of the time you may not need to care about the error code.
* NOTICE: All numbers are reversed to positive, required by wasm_bindgen.
*/
export enum BrotliDecStreamErrCode {
  BROTLI_DECODER_ERROR_FORMAT_EXUBERANT_NIBBLE,
  BROTLI_DECODER_ERROR_FORMAT_RESERVED,
  BROTLI_DECODER_ERROR_FORMAT_EXUBERANT_META_NIBBLE,
  BROTLI_DECODER_ERROR_FORMAT_SIMPLE_HUFFMAN_ALPHABET,
  BROTLI_DECODER_ERROR_FORMAT_SIMPLE_HUFFMAN_SAME,
  BROTLI_DECODER_ERROR_FORMAT_CL_SPACE,
  BROTLI_DECODER_ERROR_FORMAT_HUFFMAN_SPACE,
  BROTLI_DECODER_ERROR_FORMAT_CONTEXT_MAP_REPEAT,
  BROTLI_DECODER_ERROR_FORMAT_BLOCK_LENGTH_1,
  BROTLI_DECODER_ERROR_FORMAT_BLOCK_LENGTH_2,
  BROTLI_DECODER_ERROR_FORMAT_TRANSFORM,
  BROTLI_DECODER_ERROR_FORMAT_DICTIONARY,
  BROTLI_DECODER_ERROR_FORMAT_WINDOW_BITS,
  BROTLI_DECODER_ERROR_FORMAT_PADDING_1,
  BROTLI_DECODER_ERROR_FORMAT_PADDING_2,
  BROTLI_DECODER_ERROR_FORMAT_DISTANCE,
  BROTLI_DECODER_ERROR_DICTIONARY_NOT_SET,
  BROTLI_DECODER_ERROR_INVALID_ARGUMENTS,
  BROTLI_DECODER_ERROR_ALLOC_CONTEXT_MODES,
  BROTLI_DECODER_ERROR_ALLOC_TREE_GROUPS,
  BROTLI_DECODER_ERROR_ALLOC_CONTEXT_MAP,
  BROTLI_DECODER_ERROR_ALLOC_RING_BUFFER_1,
  BROTLI_DECODER_ERROR_ALLOC_RING_BUFFER_2,
  BROTLI_DECODER_ERROR_ALLOC_BLOCK_TYPE_TREES,
  BROTLI_DECODER_ERROR_UNREACHABLE,
}
/**
*/
export class BrotliDecStream {
  free(): void;
/**
*/
  constructor();
/**
* @param {Uint8Array} input
* @param {number} output_size
* @returns {Uint8Array}
*/
  dec(input: Uint8Array, output_size: number): Uint8Array;
/**
* @returns {number}
*/
  totalOut(): number;
/**
* @returns {number}
*/
  result(): number;
/**
* @returns {number}
*/
  lastInputOffset(): number;
}
